#include "stdafx.h"
#include "longstr.h"





void CLongString::OptimizeGrowing(int SizeAtGrow)
{
	ASSERT(SizeAtGrow!=0);
	ASSERT(m_SizeAtGrow==0);
	m_SizeAtGrow=SizeAtGrow;
	m_CurrentIndex=GetLength();
//	TRACE(" Optimize growing %d\n",m_CurrentIndex);
	m_CurrentSize=m_CurrentIndex+m_SizeAtGrow;
	m_pBuffer=GetBuffer(m_CurrentSize);
}

void CLongString::EndOptimizeGrowing()
{
	ASSERT(m_SizeAtGrow!=0);
//	TRACE("End  Optimize growing %d\n",m_CurrentIndex);
	ReleaseBuffer(m_CurrentIndex);
	m_SizeAtGrow=0;
}


CLongString::CLongString() : CString()
{
	m_SizeAtGrow=0;
};

	
const CLongString& CLongString::operator+=(TCHAR ch)
{
	if(m_SizeAtGrow==0)
		CString::operator+=(ch);
	else
	{
		if(m_CurrentIndex+1>=m_CurrentSize)
		{
			ReleaseBuffer(m_CurrentIndex);
			m_CurrentSize=m_CurrentIndex+m_SizeAtGrow;
			m_pBuffer=GetBuffer(m_CurrentSize);		
		}
		m_pBuffer[m_CurrentIndex++]=ch;
	}
	return *this;
}

const CLongString& CLongString::operator+=(LPCTSTR lpsz)
{
	if(m_SizeAtGrow==0)
		CString::operator+=(lpsz);
	else
	{
		int Len=strlen(lpsz);
//	TRACE(" Piege %d CString+= %s\n",m_CurrentIndex,lpsz);
		if(m_CurrentIndex+Len>=m_CurrentSize)
		{
			ReleaseBuffer(m_CurrentIndex);
			m_CurrentSize=m_CurrentIndex;
			while(m_CurrentIndex+Len>=m_CurrentSize)
				m_CurrentSize+=m_SizeAtGrow;
			m_pBuffer=GetBuffer(m_CurrentSize);		
		}
		memcpy(&m_pBuffer[m_CurrentIndex],lpsz,Len);
		m_CurrentIndex+=Len;
	}
	return *this;
}



const CLongString& CLongString::operator+=(const CString& string)
{  // Process like a LPCSTR
	LPCSTR lpsz=string;
	CLongString::operator+=(lpsz);
	return *this;
}