// temail.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "temail.h"
#include "..\TOLtransport\smtp.h"
#include "..\TOLtransport\mimemessage.h"


#define MYSELF "\"Tester Destination\"<tester@somewhere.someext>"
#define MAILSERVER "mail.aol.com!"
#define FROM MYSELF
#define ATTACHMENT "d:\\temail\\temail.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;



void SendSMTP(CMIMEMessage *pMsg) 
{
		CString Msg;
		CSMTP smtp(MAILSERVER);
		while(!smtp.Connect())
		{
			Msg = "Connexion fail : ";
			Msg += smtp.GetLastError();
			Msg += ". Cliquer OK pour recommencer.";
			if(AfxMessageBox(Msg,MB_OKCANCEL)!=IDOK)
				throw false;
		}

		int Try =0;
		while(!smtp.SendMessage(pMsg,true))
		{
			CString Errr("Email fail <");
			Errr += pMsg->m_sSubject;
			Errr += "> : ";
			Errr += smtp.GetLastError();
			Errr += "A:";
			for( int i = 0; i < pMsg->GetNumRecipients(); i++ )
			{
				CMailMessage::typeRecipient Type;
				CString sEmail,sFriendly;
				pMsg->GetRecipient( sEmail, sFriendly, Type, i );
				Errr += ( i > 0 ? _T( "," ) : _T( "" ) );
				Errr += sFriendly;
				Errr += _T( "<" );
				Errr += sEmail;
				Errr += _T( ">" );
			}

			Errr += "\nClick OK to retry, else abort witohut sending this email!";
			if(Try++ %3 == 0)
			{
				if(AfxMessageBox(Errr,MB_OKCANCEL | MB_ICONSTOP)==IDCANCEL) break;
			}
		}
		delete pMsg;

		if(!smtp.Disconnect())
		{
			Msg= "Error in SMTP Disconnect : Email maybe not sent! " + smtp.GetLastError();
			AfxMessageBox(Msg);
		}

}

void TestSimpleMail() // This should be compatible with Wes Clyburn original implementation
{
	CMIMEMessage *pMsg= new CMIMEMessage;
	pMsg->m_sFrom = FROM;
	pMsg->AddMultipleRecipients(MYSELF);
#ifdef BCC
	pMsg->AddMultipleRecipients("\"The other one\"<otherone@there.far>",CMailMessage::BCC); // New
#endif
	pMsg->m_sSubject = "Test CMIMEmessage";
	CString Text("Text that appear when not testing HTML or client not having HTML\r\n\r\n");
	pMsg->m_sBody += Text; // Case no HTML
	pMsg->FormatMessage();
	SendSMTP(pMsg);
}



void TestSimpleMailWithAttach() // This should be compatible with Wes Clyburn original implementation
{				// Compatible only if CMIMEMessage::APPLICATION_OCTETSTREAM coded with enum (and not hard int!)
	CMIMEMessage *pMsg= new CMIMEMessage;
	pMsg->m_sFrom = FROM;
	pMsg->AddMultipleRecipients(MYSELF);
	pMsg->m_sSubject = "Test CMIMEmessage";
	CString Text("Text that appear when not testing HTML or client not having HTML\r\n\r\n");
	pMsg->m_sBody += Text; // Case no HTML
	// Add attachment ( Old format version of AddMIMEPart, compatible with Wes interface)
	pMsg->AddMIMEPart(ATTACHMENT,CMIMEMessage::APPLICATION_OCTETSTREAM,"");
	pMsg->FormatMessage();
	SendSMTP(pMsg);

}


CString GetHTMLResource(int ID) 
{
	CString Res;
	LPCTSTR lpszName = MAKEINTRESOURCE(ID);
	HINSTANCE hInst = AfxGetResourceHandle();
	HRSRC hrInfo = ::FindResource(hInst, lpszName, RT_HTML);
	if(hrInfo==0)
	{
		CString Err; 
//		GetLastMsgError(Err);
		TRACE("%s\n",Err);
	}
	HANDLE hr = LoadResource(hInst, hrInfo);
	int Len= SizeofResource(hInst,hrInfo);  
	char *pRes= (char*) LockResource(hr);
	char *p= Res.GetBuffer(Len);
	memcpy(p,pRes,Len);
	Res.ReleaseBuffer(Len);
	return Res;
}



void TestHTMLMail() // We quit here the compatibility with Wes Clyburn orginal implementation
{
	CMIMEMessage *pMsg= new CMIMEMessage;
	pMsg->m_sFrom = FROM;
	pMsg->AddMultipleRecipients(MYSELF);
	pMsg->m_sSubject = "Test CMIMEmessage";
	CString Text("Text that appear when not testing HTML or client not having HTML\r\n\r\n");

	CMIMEMessage::CMIMEPart *pMIMEAlternative = pMsg->AddMIMEPart(CMIMEMessage::ALTERNATIVE);
	pMIMEAlternative->AddMIMEPart(CMIMEMessage::TEXT_PLAIN,Text);
	CString Html;
	Html=GetHTMLResource(IDR_HTML1);
	pMIMEAlternative->AddMIMEPart(CMIMEMessage::TEXT_HTML,Html);
	pMsg->FormatMessage();
	SendSMTP(pMsg);

}


void GetGIFResource(int ID, char** pResource, int *pLen) 
{
	CString Res;
	LPCTSTR lpszName = MAKEINTRESOURCE(ID);
	HINSTANCE hInst = AfxGetResourceHandle();
	HRSRC hrInfo = ::FindResource(hInst, lpszName, "GIF");
	if(hrInfo==0)
	{
		CString Err; 
//		GetLastMsgError(Err);
//		TRACE("%s\n",Err);
		*pLen=0;
		ASSERT(FALSE);
		return;
	}
	HANDLE hr = LoadResource(hInst, hrInfo);
	*pLen= SizeofResource(hInst,hrInfo);  
	*pResource= (char*) LockResource(hr);
	return;
}


void TestHTMLMailWithGif()
{
	CMIMEMessage *pMsg= new CMIMEMessage;
	pMsg->m_sFrom = FROM;
	pMsg->AddMultipleRecipients(MYSELF);
	pMsg->m_sSubject = "Test CMIMEmessage";
	CString Text("Text that appear when not testing HTML or client not having HTML\r\n\r\n");
	CMIMEMessage::CMIMEPart *pMIMErelated = pMsg->AddMIMEPart(CMIMEMessage::RELATED);
	CMIMEMessage::CMIMEPart *pMIMEalternative =  pMIMErelated->AddMIMEPart(CMIMEMessage::ALTERNATIVE);
	pMIMEalternative->AddMIMEPart(CMIMEMessage::TEXT_PLAIN,Text);
	CString Html;
	Html=GetHTMLResource(IDR_HTML1);
	pMIMEalternative->AddMIMEPart(CMIMEMessage::TEXT_HTML,Html);
	char* Gif;
	int Len;
	GetGIFResource(IDR_TOLLOGO, &Gif, &Len);
	pMIMErelated->AddMIMEPart(CMIMEMessage::APPLICATION_OCTETSTREAM_IMAGE,Gif,CMIMEMessage::MEMORY,"IDR_TOLLOGO",Len);
	GetGIFResource(IDR_HR, &Gif, &Len);
	pMIMErelated->AddMIMEPart(CMIMEMessage::APPLICATION_OCTETSTREAM_IMAGE,Gif,CMIMEMessage::MEMORY,"IDR_HR",Len);
	pMsg->FormatMessage();
	SendSMTP(pMsg);

}







void TestHTMLMailWithGifWithAttach()
{
	// Create and initialize a message
	CMIMEMessage *pMsg= new CMIMEMessage; 
	pMsg->m_sFrom = FROM;
	pMsg->AddMultipleRecipients(MYSELF);
	pMsg->AddMultipleRecipients("john@brown.family",CMailMessage::BCC);
	pMsg->m_sSubject = "Test CMIMEmessage";
	// Create MIME containers
	CMIMEMessage::CMIMEPart *pMIMEmixed = pMsg->AddMIMEPart(CMIMEMessage::MIXED);
	CMIMEMessage::CMIMEPart *pMIMErelated = pMIMEmixed->AddMIMEPart(CMIMEMessage::RELATED);
	CMIMEMessage::CMIMEPart *pMIMEalternative = 
			 pMIMErelated->AddMIMEPart(CMIMEMessage::ALTERNATIVE);
	// Alternative 1 : mail client does not support HTML...
	//      tell it in plain text 7Bits (warning : no conversion is done)
	CString Text("Text that appear when client does not support HTML\r\n\r\n");
	pMIMEalternative->AddMIMEPart(CMIMEMessage::TEXT_PLAIN,Text);
	// Alternative 2 : mail client does support HTML...
	//      tell it in HTML text quoted-printable (warning : no conversion is done)
	CString Html;
	Html=GetHTMLResource(IDR_HTML1);
	pMIMEalternative->AddMIMEPart(CMIMEMessage::TEXT_HTML,Html);
	// Prepare GIF image
	char* Gif;
	int Len;
	GetGIFResource(IDR_TOLLOGO, &Gif, &Len);
	// GIFS are related to HTML text : note the string "IDR_TOLLOGO"
		// which appears somewhere in IDR_HTML1 text
	pMIMErelated->AddMIMEPart
		(CMIMEMessage::APPLICATION_OCTETSTREAM_IMAGE,
					Gif,CMIMEMessage::MEMORY,"IDR_TOLLOGO",Len);
	GetGIFResource(IDR_HR, &Gif, &Len);
	pMIMErelated->AddMIMEPart(CMIMEMessage::APPLICATION_OCTETSTREAM_IMAGE,
					Gif,CMIMEMessage::MEMORY,"IDR_HR",Len);
	// Add attachment
	pMIMEmixed->AddMIMEPart(CMIMEMessage::APPLICATION_OCTETSTREAM,ATTACHMENT);
	// Do not forget to...
	pMsg->FormatMessage();
	// Then ...
	SendSMTP(pMsg);

}




int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		TestSimpleMail();
		TestSimpleMailWithAttach();
		TestHTMLMail();
		TestHTMLMailWithGif();
		TestHTMLMailWithGifWithAttach();
	}
	return 0;

}



/*

Sample for notification 

class CNotifiedMIMEMessage : public CMIMEMessage  
{
public:
	CNotifiedMIMEMessage(CProcessingDialog *p);
private:
	void NotifyProgress(int Encoding,LPCSTR Filnam);
	CProcessingDialog *m_pDlg;
	CString m_Filnam;
};


CNotifiedMIMEMessage::CNotifiedMIMEMessage(CProcessingDialog *p)
	: CMIMEMessage()
{
	m_pDlg=p;

}
void CNotifiedMIMEMessage::NotifyProgress(int Encoding,LPCSTR Filnam)
{
	if(Filnam!=NULL) m_Filnam=Filnam;
	CString Title;
	if(Encoding<1)  m_pDlg->UpdateTitle("Initializing");
	else if(Encoding>2)
	{
		Title.Format("Encoding %s %dK",m_Filnam,Encoding);
		m_pDlg->UpdateTitle(Title);
	}
	else
	{
		Title.Format("Sending %s",m_Filnam);
		m_pDlg->UpdateTitle(Title);
	}
	TRACE(" ===Title %s",Title);
}


/////////////////////////////////////////////////////////////////////////////
// CProcessingDialog dialog

class CProcessingDialog : public CDialog
{
// Construction
public:
	CProcessingDialog(CWnd* pParent = NULL);   // standard constructor
	void UpdateTitle(LPCSTR Title);

// Dialog Data
	//{{AFX_DATA(CProcessingDialog)
	enum { IDD = IDD_PROCESSING };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProcessingDialog)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CWnd * m_pAvancement;

	// Generated message map functions
	//{{AFX_MSG(CProcessingDialog)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CProcessingDialog dialog


CProcessingDialog::CProcessingDialog(CWnd* pParent )
	: CDialog(CProcessingDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CProcessingDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CProcessingDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CProcessingDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CProcessingDialog, CDialog)
	//{{AFX_MSG_MAP(CProcessingDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProcessingDialog message handlers
void CProcessingDialog::UpdateTitle(LPCSTR Title)
{
	m_pAvancement->SetWindowText(Title);
}






BOOL CProcessingDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
 	m_pAvancement=GetDlgItem(IDC_TITRE);	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


*/